import colors from './colors.js';

const docBody = document.body;

const channel = 'ts_kroony';
const { chat } = new window.TwitchJs({ channel });
const effects = {
    "bits": 1,
    "fire": 2,
    "fireworks": 3
}

const clockIP = '192.168.5.115';
const butterflyIP = '192.168.5.143';
const squidsIP = '192.168.5.31';
const starIP = '192.168.5.199';
const coffinIP = '192.168.5.220';

var currentEffect = 1;

var isMusicMode = true;

//const LedFxData = "{\"spectrum(Reactive)\": {\"background_color\": \"green\"}}";
//const LedFxData = "{\"type\":\"magnitude(Reactive)\",\"config\":{\"frequency_range\":\"Bass (60-250Hz)\"}}";

//var requestOptions = {
//  method: 'POST',
//  body: LedFxData,
//  redirect: 'follow'
//};

//fetch("http://127.0.0.1:8888/api/devices/butterfly/effects", requestOptions)
//  .then(response => response.text())
// .then(result => console.log(result))
//  .catch(error => console.log('error', error));

console.log('[SYS] WLED Chatbot Overlay initalized');

chat.connect().then(() => {
    chat.join(channel);
    console.log('[SYS] Channel joined');

    // Reset WLED to default effect (android=1)
    //fetch(`http://192.168.5.115/win&PL=3`)
    //    .then(() => {
    //        console.log(`[SENT] WLED initialized with default effect`);
    //    });
}).catch((e) => { console.error('Twitch error in Promise', e); });
// chat.on('PRIVMSG', (message) => {
chat.on('PRIVMSG', (message) => {
    const username = message.tags.displayName;
    const userColor = message.tags.color.replace('#', '');
    const rewardID = message.tags.customRewardId; //undefined if empty
    const tags = message.tags;
    
    //console.log('Username: ' + username);
    //console.log('reward ID: ' + rewardID);
    //console.log('user color: ' + userColor);
    console.log('chat message: ' + JSON.stringify(message));
    // Sanitize user input
    message = JSON.parse(JSON.stringify(message.message));
    
    
    if(message.startsWith('!musicLights ') && message != '!musicLights ') {
      if( tags.badges.broadcaster =! 1 ) { error('Yeh nah thats just for Kroony'); return; } //make it just for me
      if(message == '!musicLights on') { //switch between music mode and not
        isMusicMode = true;
        successText('Music Lights Activated');
      }
      else if(message == '!musicLights off') { 
        isMusicMode = false;
        fetch("http://localhost:8888/api/scenes", {
            "headers": {
              "accept": "application/json, text/plain, */*",
              "content-type": "application/json",
            },
            "body": "{\"id\":\"off\",\"action\":\"activate\"}",
            "method": "PUT",
            "mode": "cors",
            "credentials": "omit"
          }).then(() => {
            successText('Music Lights Deactivated');
          });
      }
      
    }
    else if(message.startsWith('!colour ') && message != '!colour ') { //clock (named colour)
      wLED_color_change(message.replace('!colour ', '').replace('#', ''), username, userColor, clockIP, 'Clock');
    }
    else if(message.startsWith('!clock ') && message != '!clock ') { //clock
      wLED_color_change(message.replace('!clock ', '').replace('#', ''), username, userColor, clockIP, 'Clock');
    }
    else if(message.startsWith('!squids ') && message != '!squids ') { //squids
      wLED_color_change(message.replace('!squids ', '').replace('#', ''), username, userColor, squidsIP, 'Squids');
    }
    else if(message.startsWith('!star ') && message != '!star ') { //star
      wLED_color_change(message.replace('!star ', '').replace('#', ''), username, userColor, starIP, 'Star');
    }
    /*else if(message.startsWith('!coffin ') && message != '!coffin ') { //star
      wLED_color_change(message.replace('!coffin ', '').replace('#', ''), username, userColor, coffinIP, 'Coffin');
    }*/
    else if(message.startsWith('!butterfly ') && message != '!butterfly ') { //butterfly
    
      // Only allow Mods, VIPs and Subs to change color
      if(!(tags.mod == 1 || tags.badges.vip == 1 || tags.subscriber == 1)) { //check if sub
          error('Butterfly is for Subs only!');
          return;
      }
      
      if(isMusicMode == true) {
        if(message == '!butterfly unicornvomit' || message == '!butterfly unicorn_vomit' || message == '!butterfly unicorn vomit' ) {
          fetch("http://localhost:8888/api/scenes", {
            "headers": {
              "accept": "application/json, text/plain, */*",
              "content-type": "application/json",
            },
            "body": "{\"id\":\"unicorn-vomit\",\"action\":\"activate\"}",
            "method": "PUT",
            "mode": "cors",
            "credentials": "omit"
          }).then(() => {
            console.log(`[SENT] Word color request [unicorn vomit] sent`);
            success(username, 'colorname', 'unicorn vomit');
          });
        }
        
        else if(message == '!butterfly green') {
          fetch("http://localhost:8888/api/scenes", {
            "headers": {
              "accept": "application/json, text/plain, */*",
              "content-type": "application/json",
            },
            "body": "{\"id\":\"green\",\"action\":\"activate\"}",
            "method": "PUT",
            "mode": "cors",
            "credentials": "omit"
          }).then(() => {
            console.log(`[SENT] Word color request [unicorn vomit] sent`);
            success(username, 'colorname', 'green');
          });
        }
        
        else if(message == '!butterfly red') {
          fetch("http://localhost:8888/api/scenes", {
            "headers": {
              "accept": "application/json, text/plain, */*",
              "content-type": "application/json",
            },
            "body": "{\"id\":\"red\",\"action\":\"activate\"}",
            "method": "PUT",
            "mode": "cors",
            "credentials": "omit"
          }).then(() => {
            console.log(`[SENT] Word color request [unicorn vomit] sent`);
            success(username, 'colorname', 'red');
          });
        }
        
        else if(message == '!butterfly blue') {
          fetch("http://localhost:8888/api/scenes", {
            "headers": {
              "accept": "application/json, text/plain, */*",
              "content-type": "application/json",
            },
            "body": "{\"id\":\"blue\",\"action\":\"activate\"}",
            "method": "PUT",
            "mode": "cors",
            "credentials": "omit"
          }).then(() => {
            console.log(`[SENT] Word color request [unicorn vomit] sent`);
            success(username, 'colorname', 'blue');
          });
        }
        
        else if(message == '!butterfly energy') {
          fetch("http://localhost:8888/api/scenes", {
            "headers": {
              "accept": "application/json, text/plain, */*",
              "content-type": "application/json",
            },
            "body": "{\"id\":\"energy\",\"action\":\"activate\"}",
            "method": "PUT",
            "mode": "cors",
            "credentials": "omit"
          }).then(() => {
            console.log(`[SENT] Word color request [unicorn vomit] sent`);
            success(username, 'colorname', 'energy');
          });
        }
        
        else if(message == '!butterfly magenta') {
          fetch("http://localhost:8888/api/scenes", {
            "headers": {
              "accept": "application/json, text/plain, */*",
              "content-type": "application/json",
            },
            "body": "{\"id\":\"magenta\",\"action\":\"activate\"}",
            "method": "PUT",
            "mode": "cors",
            "credentials": "omit"
          }).then(() => {
            console.log(`[SENT] Word color request [unicorn vomit] sent`);
            success(username, 'colorname', 'magenta');
          });
        }
      } else { //NORMAL BUTTERFLY CODE not music
        if(message.startsWith('!butterfly ') && message != '!butterfly ') { //clock
          wLED_color_change(message.replace('!butterfly ', '').replace('#', ''), username, userColor, butterflyIP, 'Buttterfly');
        }
      }
    }
    else if(message.startsWith('!')) //unknown command
    {
      error('Yeh nah, I dont know what that command is.');
    }
    // Select next effect
    /*else if(message == '!fx') {
        // Increase effect ID
        currentEffect = currentEffect + 1;
        if(currentEffect > Object.values(effects).length) {
            currentEffect = 1;
        }

        const keys = Object.keys(effects);
        const currentKeyName = keys[currentEffect-1];

        console.log(`[REQ] Next effect requested [${currentEffect}]`);

        fetch(`http://192.168.5.115/win&PL=${currentEffect}`)
            .then(() => {
                console.log(`[SENT] Effect [ID ${currentEffect}] request sent`);
                success(username, 'fx', currentKeyName);
            });
    }

    // Select specific preset/effect
    else if(message.startsWith('!fx') && message != '!fx ') {
        let effect = message.replace('!fx ', '');
        console.log(`[REQ] Requested effect [${effect}]`);
        if(!(effect in effects)) {
            console.log(`[ERR] Denying effect request, [${effect}] is no valid effect`);
            error('Effect Not Found');
            return;
        }

        let effectId = effects[effect];
        currentEffect = effectId;
        console.log(`[REQ] Requested effect [${effect}] [ID ${effectId}]`);
        fetch(`http://192.168.5.115/win&PL=${effectId}`)
            .then(() => {
                console.log(`[SENT] Effect [${effect}] [ID ${effectId}] request sent`);
                success(username, 'fx', effect);
            });
    } else {
      //console.log('chat message: ' + message);
    }*/
});

function componentToHex(c) {
    var hex = parseInt(c).toString(16);
    return hex.length == 1 ? "0" + hex : hex;
}

function rgbToHex(rgb) {
    rgb = rgb.split(",");
    return componentToHex(rgb[0]) + componentToHex(rgb[1]) + componentToHex(rgb[2]);
}

function success(username, type, input) {
    // Feedback div element
    const holder = document.createElement('div');
    holder.id = 'feedback-info';
    holder.classList.add('animate__animated');

    // User username to feedback info
    const userlabel = `<span class="username">${username}</span>`;
    holder.innerHTML = userlabel;

    // Handle effect requests
    if(type == 'fx') {
        const fxHolder = document.createElement('span');
        fxHolder.classList.add('fx');
        fxHolder.innerText = input;
        holder.append(fxHolder);
    // Handle color requests
    } else {
        // Color element
        const colorHolder = document.createElement('span');
        colorHolder.classList.add('color');

        // Color square element (color preview)
        const colorSquare = document.createElement('div');
        colorSquare.classList.add('color-square');
        if(type === 'rgb') {
            colorSquare.style.backgroundColor = `rgb(${input})`;
        } else {
            colorSquare.style.backgroundColor = input;
        }

        // Add requested color to output
        colorHolder.innerText = input; // message text
        colorHolder.prepend(colorSquare);

        // Append result to feedback info element
        holder.append(colorHolder);
    }

    // Show result
    holder.classList.add('animate__backInRight');
    docBody.append(holder);

    // Hide result after 3 secs
    setTimeout(function() {
        holder.classList.remove('animate__backInRight');
        holder.classList.add('animate__backOutRight');
        setTimeout(function() {
            holder.remove();
        }, 1000);
    }, 5000);
}

function successText(input) {
    // Feedback div element
    const holder = document.createElement('div');
    holder.id = 'feedback-info';
    holder.classList.add('animate__animated');

    
    // Color element
    const colorHolder = document.createElement('span');
    colorHolder.classList.add('color');

    // Add requested color to output
    colorHolder.innerText = input; // message text

    // Append result to feedback info element
    holder.append(colorHolder);

    // Show result
    holder.classList.add('animate__backInRight');
    docBody.append(holder);

    // Hide result after 3 secs
    setTimeout(function() {
        holder.classList.remove('animate__backInRight');
        holder.classList.add('animate__backOutRight');
        setTimeout(function() {
            holder.remove();
        }, 1000);
    }, 5000);
}

function successNamed(username, usernameColor, type, input, deviceName) {
    // Feedback div element
    const holder = document.createElement('div');
    holder.id = 'feedback-info';
    holder.classList.add('animate__animated');

    // User username to feedback info
    const userlabel = `<span class="username" style="color:${usernameColor};">${username}</span>`;
    holder.innerHTML = userlabel;

    // Handle effect requests
    if(type == 'fx') {
        const fxHolder = document.createElement('span');
        fxHolder.classList.add('fx');
        fxHolder.innerText = input;
        holder.append(fxHolder);
    // Handle color requests
    } else {
        // Color element
        const colorHolder = document.createElement('span');
        colorHolder.classList.add('color');

        // Color square element (color preview)
        const colorSquare = document.createElement('div');
        colorSquare.classList.add('color-square');
        if(type === 'rgb') {
            colorSquare.style.backgroundColor = `rgb(${input})`;
        } else {
            colorSquare.style.backgroundColor = input;
        }

        // Add requested color to output
        colorHolder.innerText = input + ' -> ' + deviceName; // message text
        colorHolder.prepend(colorSquare);

        // Append result to feedback info element
        holder.append(colorHolder);
    }

    // Show result
    holder.classList.add('animate__backInRight');
    docBody.append(holder);

    // Hide result after 3 secs
    setTimeout(function() {
        holder.classList.remove('animate__backInRight');
        holder.classList.add('animate__backOutRight');
        setTimeout(function() {
            holder.remove();
        }, 1000);
    }, 5000);
}

function error(text) {
    // Feedback div element
    const holder = document.createElement('div');
    holder.id = 'feedback-info';
    holder.classList.add('animate__animated');

    // Get feedback info element
    holder.classList.add('error');
    holder.innerHTML = `<span class="error-details">${text}</span><span class="error-meta">Oops... try again?</span>`;

    // Show result
    holder.classList.add('animate__backInRight');
    docBody.append(holder);

    // Hide result after 5 secs
    setTimeout(function() {
        holder.classList.remove('animate__backInRight');
        holder.classList.add('animate__backOutRight');
        setTimeout(function() {
            holder.classList.remove('error');
            holder.remove();
        }, 1000);
    }, 5000);
}

function wLED_color_change(chatArgs, username, usernameColor, ipaddress, deviceName) {
  let color = chatArgs;
  console.log(`[REQ] Requested color [${color}]`);
  console.log(`[SENT] Hex color request [${color}] sent`);

  // Only allow Mods, VIPs and Subs to change color
  // if(!(message.tags.mod == 1 || message.tags.badges.vip == 1 || message.tags.subscriber == 1)) {
  //     return;
  // }

  // Color is text based an in list of CSS3 colors
  if(color in colors) {
      const colorName = color;
      color = colors[color];
      fetch(`http://${ipaddress}/win&CL=h${color}`)
          .then(() => {
              console.log(`[SENT] Word color request [${color}] sent`);
              successNamed(username, usernameColor, 'colorname', colorName, deviceName);
          });
  }
  // Check if color is hex value
  else if(/^[0-9A-F]{6}$/i.test(color)) {
      fetch(`http://${ipaddress}/win&CL=h${color}`)
          .then(() => {
              console.log(`[SENT] Hex color request [${color}] sent`);
              successNamed(username, usernameColor, 'hex', '#'+color, deviceName);
          });
  }
  // Check if color is valid RGB statement (0-255,0-255,0-255)
  else if(/(25[0-5]|2[0-4][0-9]|[1]?[0-9][0-9]?)\,(25[0-5]|2[0-4][0-9]|[1]?[0-9][0-9]?)\,(25[0-5]|2[0-4][0-9]|[1]?[0-9][0-9]?)/.test(color)) {
      const colorRgb = color;
      color = rgbToHex(color);
      fetch(`http://${ipaddress}/win&CL=h${color}`)
      .then(() => {
          console.log(`[SENT] RGB color request [${color}] sent`);
          successNamed(username, usernameColor, 'rgb', colorRgb, deviceName);
      });
  }
  else {
      console.log(`[ERR] No valid color [${color}] specified`);
      error('Colour Not Found');
  }
}